
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Comment_reactionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const comment_reactions = await db.comment_reactions.create(
            {
                id: data.id || undefined,
        
        emoji: data.emoji
        ||
        null
            ,
            
        reacted_at: data.reacted_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await comment_reactions.setComment( data.comment || null, {
            transaction,
        });
        
        await comment_reactions.setUser( data.user || null, {
            transaction,
        });
        
        await comment_reactions.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return comment_reactions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const comment_reactionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                emoji: item.emoji
            ||
            null
            ,
            
                reacted_at: item.reacted_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const comment_reactions = await db.comment_reactions.bulkCreate(comment_reactionsData, { transaction });

        // For each item created, replace relation files
        

        return comment_reactions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const comment_reactions = await db.comment_reactions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.emoji !== undefined) updatePayload.emoji = data.emoji;
        
        
        if (data.reacted_at !== undefined) updatePayload.reacted_at = data.reacted_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await comment_reactions.update(updatePayload, {transaction});

        
        
        if (data.comment !== undefined) {
            await comment_reactions.setComment(
              
              data.comment,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await comment_reactions.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await comment_reactions.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return comment_reactions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const comment_reactions = await db.comment_reactions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of comment_reactions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of comment_reactions) {
                await record.destroy({transaction});
            }
        });


        return comment_reactions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const comment_reactions = await db.comment_reactions.findByPk(id, options);

        await comment_reactions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await comment_reactions.destroy({
            transaction
        });

        return comment_reactions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const comment_reactions = await db.comment_reactions.findOne(
            { where },
            { transaction },
        );

        if (!comment_reactions) {
            return comment_reactions;
        }

        const output = comment_reactions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.comment = await comment_reactions.getComment({
            transaction
        });
        
        
        output.user = await comment_reactions.getUser({
            transaction
        });
        
        
        output.organizations = await comment_reactions.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.comments,
        as: 'comment',
        
        where: filter.comment ? {
          [Op.or]: [
            { id: { [Op.in]: filter.comment.split('|').map(term => Utils.uuid(term)) } },
            {
              body: {
                [Op.or]: filter.comment.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.emoji) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'comment_reactions',
                        'emoji',
                        filter.emoji,
                    ),
                };
            }
            

            
            

            
            if (filter.reacted_atRange) {
                const [start, end] = filter.reacted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reacted_at: {
                    ...where.reacted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reacted_at: {
                    ...where.reacted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.comment_reactions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'comment_reactions',
                        'emoji',
                        query,
                    ),
                ],
            };
        }

        const records = await db.comment_reactions.findAll({
            attributes: [ 'id', 'emoji' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['emoji', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.emoji,
        }));
    }

    
};

